using Model;

namespace Services;

public interface ITacticService
{

    public Task<IEnumerable<Tactic>> ListTacticsOf(int userId);
    
    public Task<bool> HasAnyRights(int userId, int tacticId);

    public Task<bool> UpdateName(int tacticId, string name);
    public Task<bool> SetTacticStepContent(int tacticId, int stepId, string json);
    public Task<string?> GetTacticStepContent(int tacticId, int stepId);
    public Task<IEnumerable<Tactic>> ListUserTactics(int userId);
    public Task<int> AddTacticStep(int tacticId, int parentStepId, string initialJson);
    public Task<bool> RemoveTacticStep(int tacticId, int stepId);
}